#include <time.h>
#include <stdio.h>

#include "loops.h"

extern void time0(void);
extern void time1(void);
extern void time2(void (*)(void));

void foo(void) {
}

int main (void) {
    clock_t start, stop;
    double seconds;

    start = clock();
    time0();
    stop = clock();
    seconds = ((double) (stop - start))/((double) CLOCKS_PER_SEC);
    printf("time0(): %lu loops in %f seconds = %f nanoseconds/loops\n",
           (unsigned long) LOOPS, seconds, 1000000000.0 * seconds/((double) LOOPS));


    start = clock();
    time1();
    stop = clock();
    seconds = ((double) (stop - start))/((double) CLOCKS_PER_SEC);
    printf("time1(): %lu loops in %f seconds = %f nanoseconds/loops\n",
           (unsigned long) LOOPS, seconds, 1000000000.0 * seconds/((double) LOOPS));

    start = clock();
    time2(&foo);
    stop = clock();
    
    seconds = ((double) (stop - start))/((double) CLOCKS_PER_SEC);
    printf("time2(): %lu loops in %f seconds = %f nanoseconds/loops\n",
           (unsigned long) LOOPS, seconds, 1000000000.0 * seconds/((double) LOOPS));
    return 0;
}

